// MemoSendAttachWnd.cpp :  Դϴ.
//

#include "stdafx.h"
#include "NeMessenger.h"
#include "MemoSendAttachWnd.h"
#include "NeMessengerDlg.h"

#define WM_MY_CLOSE_MESSAGE   (WM_USER + 123456)
// CMemoSendAttachWnd
#define NAME_MY_PC_BTN		_T("MyPC")
#define NAME_EXPAND_CKBOX	_T("CkExpand")
#define NAME_RESERVE_CKBOX	_T("CkReserve")

#define DEF_MEMOSEND_MYPC_HEIGHT 26
#define DEF_MEMOSEND_MYPC_WIDTH  27

IMPLEMENT_DYNAMIC(CMemoSendAttachWnd, CWnd)

REAL rFontHeight = 9.0;
CMemoSendAttachWnd::CMemoSendAttachWnd()
{
	m_bExpand = FALSE;
	// BG

	m_pImgBG = NULL;
	m_crBG = DEF_MEMOSEND_ATTACH_BG_COLOR;
	m_crCenterline = DEF_MEMOSEND_ATTACH_BGCENTERLINE_COLOR;
	m_crOutline = DEF_MEMOSEND_ATTACH_BGOUTLINE_COLOR;
	m_crProgressOutline = DEF_MEMOSEND_ATTACH_PROGRESS_OUTLINE;

	// dimension
	m_rtWnd.SetRectEmpty();
	m_rtTitle.SetRectEmpty();
	m_rcMyPC.SetRectEmpty();
	m_szTitle = CSize(0, 0);
	m_szMyPC = CSize(0, 0);
	m_szReserve = CSize(0, 0);
	m_rtSendSpeedTitle.SetRectEmpty();
	m_szSendSpeedTitle = CSize(0, 0);
	m_szSendSpeedValue = CSize(0, 0);
	m_rtSendSpeedValue.SetRectEmpty();
	m_rtRemainTimeTitle.SetRectEmpty();
	m_szRemainTimeTitle = CSize(0, 0);
	m_rtRemainTimeValue.SetRectEmpty();
	m_rtFileSizeText.SetRectEmpty();
	m_rtCurSendProgressText.SetRectEmpty();
	m_rtTotalProgressText.SetRectEmpty();
	m_rtFileSizeProgress.SetRectEmpty();
	m_rtFileList.SetRectEmpty();

	
	m_strTitle = _T("");
	m_strMyPC.Empty();

	m_strSendSpeedTitle = _T("");
	m_strSendSpeedValue = _T("");
	m_strRemainTimeTitle = _T("");
	m_strRemainTimeValue = _T("");
	m_dwTotalSize = 0;
	m_dwCurSendSize = 0;
	m_strProgressSize = _T("");
	m_strCurProgressSizeText.Empty();
	m_strTotalSizeText.Empty();

	// attribute
	m_nFontHeightTitle = DEF_MEMOSEND_ATTACH_TITLE_FONT_HEIGHT;
	m_crTitle = DEF_MEMOSEND_ATTACH_TITLE_FONT_COLOR;
	m_fontStyleTitle = DEF_MEMOSEND_ATTACH_TITLE_FONT_STYLE;
	
	m_nFontHeightKey = DEF_MEMOSEND_ATTACH_KEY_FONT_HEIGHT;
	m_crKey = DEF_MEMOSEND_ATTACH_KEY_FONT_COLOR;
	m_fontStyleKey = DEF_MEMOSEND_ATTACH_KEY_FONT_STYLE;

	m_nFontHeightValue = DEF_MEMOSEND_ATTACH_VALUE_FONT_HEIGHT;
	m_crValue = DEF_MEMOSEND_ATTACH_VALUE_FONT_COLOR;
	m_fontStyleValue = DEF_MEMOSEND_ATTACH_VALUE_FONT_STYLE;

	m_bSendStart = FALSE;
	m_pFileDlg = NULL;
    m_pBtnFileAdd = NULL;
	m_pBtnExpand = NULL;
	m_pCkBoxReserve = NULL;
//	m_bSelFileDlgIsActive = false;

	ZeroMemory(m_pImgProgressBG, sizeof(m_pImgProgressBG));
    m_pImgProgressFG = NULL;
    m_wszFontName[0] = NULL;
    m_nFontHeight = rFontHeight;
    m_fontStyle = FontStyleRegular;
}

CMemoSendAttachWnd::~CMemoSendAttachWnd()
{
}

BEGIN_MESSAGE_MAP(CMemoSendAttachWnd, CWnd)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_ERASEBKGND()
	ON_WM_PAINT()
	ON_WM_SIZE()
	ON_MESSAGE(UM_MEMOSEND_FILESIZE,			OnUmMemosendFileSize)
	ON_MESSAGE(WM_FILE_SELECTED, OnFileSelected)
	
END_MESSAGE_MAP()

int	CMemoSendAttachWnd::GetFileItemCount()
{
	if (m_listFileAttach.GetSafeHwnd())
		return m_listFileAttach.GetFileItemCount();

	return 0;
}

void CMemoSendAttachWnd::SetImgBGPath(CString strFileName)
{
	CString strImgPath = _T(""), strImgDir = _T("");

	strImgDir = GetAppImgDir();

	if (strFileName.IsEmpty())
		return;
	strImgPath.Format(_T("%s\\%s"), strImgDir, strFileName);

	m_pImgBG = new Image(strImgPath);
}

void CMemoSendAttachWnd::SetImgProgressPath(CString strFileNameFG,
											CString strFileNameBGl,
											CString strFileNameBGc,
											CString strFileNameBGr)
{
	CString strImgPath = _T(""), strImgDir = _T("");

	strImgDir = GetAppImgDir();

	if (strFileNameFG.IsEmpty())
		return;
	strImgPath.Format(_T("%s\\%s"), strImgDir, strFileNameFG);

	m_pImgProgressFG = new Image(strImgPath);

	if (strFileNameBGl.IsEmpty())
		return;
	strImgPath.Format(_T("%s\\%s"), strImgDir, strFileNameBGl);

	m_pImgProgressBG[0] = new Image(strImgPath);

	if (strFileNameBGc.IsEmpty())
		return;
	strImgPath.Format(_T("%s\\%s"), strImgDir, strFileNameBGc);

	m_pImgProgressBG[1] = new Image(strImgPath);

	if (strFileNameBGr.IsEmpty())
		return;
	strImgPath.Format(_T("%s\\%s"), strImgDir, strFileNameBGr);

	m_pImgProgressBG[2] = new Image(strImgPath);
}

void CMemoSendAttachWnd::SetFontConfig(WCHAR* wszFontName, REAL nFontHeight, FontStyle style, Color crText)
{
	_tcscpy_s(m_wszFontName, wszFontName);
	m_nFontHeight = nFontHeight;
	m_fontStyle = style;

	m_crText = crText;
}

void CMemoSendAttachWnd::SetTitle(CString strTitle)
{
	m_strTitle = strTitle;

	RedrawWindow(&m_rtTitle, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
}

void CMemoSendAttachWnd::SetSendSpeedTitle(CString strSendSpeedTitle)
{
	m_strSendSpeedTitle = strSendSpeedTitle;

	RedrawWindow(&m_rtSendSpeedTitle, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
}

void CMemoSendAttachWnd::SetSendSpeedValue(CString strSendSpeedValue)
{
	m_strSendSpeedValue = strSendSpeedValue;

	RedrawWindow(&m_rtSendSpeedValue, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
}

void CMemoSendAttachWnd::SetRemainTimeTitle(CString strRemainTimeTitle)
{
	m_strRemainTimeTitle = strRemainTimeTitle;

	RedrawWindow(&m_rtRemainTimeTitle, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
}


void CMemoSendAttachWnd::SetMyPCText( CString strMyPCValue )
{
	m_strMyPC = strMyPCValue;
}


void CMemoSendAttachWnd::SetRemainTimeValue(CString strRemainTimeValue)
{
	m_strRemainTimeValue = strRemainTimeValue;

	RedrawWindow(&m_rtRemainTimeValue, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
}

void CMemoSendAttachWnd::SetTotalSize(ULONGLONG dwTotalSize)
{
	m_dwTotalSize = dwTotalSize;

	UpdateMemoSendSize();
}

void CMemoSendAttachWnd::SetCurSendSize(ULONGLONG dwCurSendSize)
{
	m_dwCurSendSize = dwCurSendSize;
	
	UpdateMemoSendSize();
}

void CMemoSendAttachWnd::UpdateSize(ULONGLONG dwTotalSize, ULONGLONG dwCurSendSize)
{
	m_dwTotalSize = dwTotalSize;
	m_dwCurSendSize = dwCurSendSize;

	UpdateMemoSendSize();
}

void CMemoSendAttachWnd::UpdateSpeed(ULONGLONG dwSendSize, double fSeconds)
{
	double fKBSec = 0;
	if (fSeconds > 0)
		fKBSec = ((double)dwSendSize / 1024) / fSeconds;

	m_strSendSpeedValue.Format(_T("%0.2f KB/s"), fKBSec);

	ULONGLONG dwRemainSize = m_dwTotalSize - dwSendSize;

	int nSec = 0;
	if (fKBSec)
		nSec = (int)(((double)dwRemainSize / 1024) / fKBSec);
	
	int nHour = nSec / 3600;
	if (nHour)
		nSec = nSec - (nHour * 3600);

	int nMin = nSec / 60;
	if (nMin)
		nSec = nSec - (nMin * 60);
	
	COleDateTimeSpan dtRemain(0, nHour, nMin, nSec);
	m_strRemainTimeValue = dtRemain.Format(_T("%H:%M:%S"));

	_ReCalcTotalSpeedBar();
	RedrawWindow(&m_rtSendSpeedValue, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
	RedrawWindow(&m_rtRemainTimeValue, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
}

void CMemoSendAttachWnd::UpdateMemoSendSize()
{
	CString strTotalSize = _T(""), strCurSendSize = _T("");
	
	ULONGLONG dwTotalSize_K = m_dwTotalSize / 1024;
	if (m_dwTotalSize > 0 && dwTotalSize_K <= 0)
		dwTotalSize_K = 1;
	strTotalSize.Format(_T("%d"), (INT)dwTotalSize_K);
	strTotalSize = InsertCharToString(strTotalSize, 3, _T(','));

	ULONGLONG dwCurSendSize_K = m_dwCurSendSize / 1024;
	if (m_dwCurSendSize > 0 && dwCurSendSize_K <= 0)
		dwCurSendSize_K = 1;
	strCurSendSize.Format(_T("%d"), (INT)dwCurSendSize_K);
	strCurSendSize = InsertCharToString(strCurSendSize, 3, _T(','));

	m_strCurProgressSizeText = strCurSendSize;
	m_strTotalSizeText = _T("/");
	m_strTotalSizeText += strTotalSize;
	//m_strProgressSize.Format(_T("%sKB / %sKB"), strCurSendSize, strTotalSize);

	//RedrawWindow(&m_rtFileSizeText, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
	//RedrawWindow(&m_rtFileSizeProgress, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
	_ReCalcTotalSpeedBar();
	RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
}

void CMemoSendAttachWnd::AddForwardFileItem(CString strPath, CString strName, DWORD dwFileSize, int serverIndex)
{
	if (m_listFileAttach.GetSafeHwnd())
		m_listFileAttach.AddFileItem(strPath, strName, dwFileSize, serverIndex, CMemoSendAttachList::EMEMOSEND_FORWARD);
}

void CMemoSendAttachWnd::UpdateFileAttachComplete(CString strPath)
{
	if (m_listFileAttach.GetSafeHwnd())
		m_listFileAttach.UpdateFileAttachComplete(strPath);
}

void CMemoSendAttachWnd::UpdateFileDelete(int nServerIndex)
{
	if (m_listFileAttach.GetSafeHwnd())
	{
		m_listFileAttach.DeleteFileItemFromIndex(nServerIndex);
	}
}
void CMemoSendAttachWnd::UpdateFileListDelete(int nServerIndex)
{
	if (m_listFileAttach.GetSafeHwnd())
	{
		m_listFileAttach.DeleteFileListItemFromIndex(nServerIndex);
	}
}


void CMemoSendAttachWnd::UpdateFileAttachProgress(int index, DWORD dwSendLength)
{
	TRACE("%s %d %d\n", __FUNCTION__, __LINE__, index);
	if (m_listFileAttach.GetSafeHwnd())
		m_listFileAttach.UpdateFileAttachProgress(index, dwSendLength);
}

void CMemoSendAttachWnd::FileSendResultWait(int index)
{
	TRACE("%s %d %d\n", __FUNCTION__, __LINE__, index);
	if (m_listFileAttach.GetSafeHwnd())
		m_listFileAttach.FileSendResultWait(index);
}

void CMemoSendAttachWnd::FileSendResultComplete(int index)
{
	TRACE("%s %d %d\n", __FUNCTION__, __LINE__, index);
	if (m_listFileAttach.GetSafeHwnd())
		m_listFileAttach.FileSendResultComplete(index);
}

// CMemoSendAttachWnd ޽ óԴϴ.

int CMemoSendAttachWnd::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	CRect rtBtnFileAdd(0, 0, 0, 0);
	/*if (!m_btnFileAdd.Create(_T(""), WS_CHILD | WS_VISIBLE | BS_OWNERDRAW, rtBtnFileAdd, this, ID_MEMO_SEND_ADD_BTN))
		return -1;*/

	m_pBtnFileAdd = new CDUIControl<CButtonUI>(this, this);
	m_pBtnExpand = new CDUIControl<CCheckBoxUI>(this, this);
	m_pCkBoxReserve = new CDUIControl<CCheckBoxUI>(this, this);
	m_pBtnFileAdd->LoadSkin();
	m_pBtnExpand->LoadSkin();
	m_pCkBoxReserve->LoadSkin();

	//m_btnFileAdd.SetBtnBitmapFile(GetAppImgFile(_T("MemoSend_Btn_MyPC.bmp")), RGB(0, 0, 0));
	CButtonUI *pButton = m_pBtnFileAdd->GetControl();
	pButton->SetName(NAME_MY_PC_BTN);

	CCheckBoxUI *pCKBoxExpand = m_pBtnExpand->GetControl();
	pCKBoxExpand->SetName(NAME_EXPAND_CKBOX);

		CCheckBoxUI *pCKBoxReserve = m_pCkBoxReserve->GetControl();
	pCKBoxReserve->SetName(NAME_RESERVE_CKBOX);

	CString strTmpClassName = _T("");
	strTmpClassName.Format(_T("Ntalk_MemoSend_FileList_%X%X%X"),
						   GetTickCount(),
						   GetCurrentProcessId(),
						   GetCurrentThreadId());
	RegisterWindowClass(strTmpClassName);

	CRect rtFileList(0, 0, 0, 0);
	if (!m_listFileAttach.Create(strTmpClassName, _T("Ntalk_MemoSend_FileList"), WS_CHILD | WS_VISIBLE | WS_CLIPCHILDREN, rtFileList, this, ID_MEMO_SEND_ATTACH_LIST))
		return -1;
	m_listFileAttach.SetImgFilePath(_T("MemoSend_Attach_File.png"));
	m_listFileAttach.SetImgInitMsgPath(_T("img_send_message_popup_icon.png"));
	m_listFileAttach.SetInitMsgText(LoadStringFromResource(IDS_STRING452));
	m_listFileAttach.SetImgProgressPath(_T("img_chat_progressive_bar.png"), _T("img_chat_progressive_bg_l.png"),
		 _T("img_chat_progressive_bg_c.png"), _T("img_chat_progressive_bg_r.png"));
	m_listFileAttach.SetImgCancelPath(_T("btn_alarm_popup_x_on.png"), _T("btn_alarm_popup_x_off.png"));

	m_listFileAttach.SetFontConfig(g_defaultFontFaceName, 8.5, FontStyleRegular, Color(255, 102, 102, 102));

	return 0;
}

void CMemoSendAttachWnd::OnDestroy()
{
	if (m_pImgBG)
	{
		delete m_pImgBG;
		m_pImgBG = NULL;
	}

	if (m_pImgProgressFG)
	{
		delete m_pImgProgressFG;
		m_pImgProgressFG = NULL;
	}

	for (int i = 0; i < 3; i++)
	{
		SAFE_DELETE(m_pImgProgressBG[i]);
	}

	if (m_pBtnFileAdd->GetSafeHwnd())
	{
		::DestroyWindow(m_pBtnFileAdd->GetSafeHwnd());
	}

	if(m_pBtnExpand->GetSafeHwnd())
	{
		::DestroyWindow(m_pBtnExpand->GetSafeHwnd());
	}
	
	if(m_pCkBoxReserve->GetSafeHwnd())
	{
		::DestroyWindow(m_pCkBoxReserve->GetSafeHwnd());
	}

	if (m_listFileAttach.GetSafeHwnd())
		m_listFileAttach.DestroyWindow();

	CWnd::OnDestroy();
}

BOOL CMemoSendAttachWnd::OnEraseBkgnd(CDC* pDC)
{
	return TRUE;
}

void CMemoSendAttachWnd::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	
	PAINTSTRUCT ps = dc.m_ps;
	int psWidth = ps.rcPaint.right - ps.rcPaint.left;
	int psHeight = ps.rcPaint.bottom - ps.rcPaint.top;

	int nPX = ps.rcPaint.left;
	int nPY = ps.rcPaint.top;

	CRect rtPS(nPX, nPY, nPX + psWidth, nPY + psHeight);

    CRect rt(0, 0, 0, 0);
	GetClientRect(&rt);
	int nWndWidth = rt.Width();
	int nWndHeight = rt.Height();

	HDC hdc = dc.GetSafeHdc();

	HDC	hdcMemory = CreateCompatibleDC(hdc);

	if (hdcMemory == NULL)
		return;

	HBITMAP hbmpMem = CreateCompatibleBitmap(hdc, psWidth, psHeight);

	HGDIOBJ hbmpOld = ::SelectObject(hdcMemory,  hbmpMem);

	Graphics graph(hdcMemory);

	if (hbmpMem)
	{
		graph.SetSmoothingMode(SmoothingModeAntiAlias);
		graph.SetInterpolationMode(InterpolationModeHighQualityBicubic);
		graph.SetPageUnit(UnitPixel);

		ImageAttributes ImgAttr;

		SolidBrush brushBG(m_crBG);
		Pen penBG(m_crOutline, 1);
		int nSX = 0, nSY = 0, nCX = 0, nCY = 0, nEX = 0, nEY = 0;
		if (m_pImgBG)
			DrawImageToStretchHorz(&graph, m_pImgBG, &rtPS, &m_rtWnd, m_crBG, &ImgAttr);
		else
		{
			nSX = m_rtWnd.left - rtPS.left;
			nSY = m_rtWnd.top - rtPS.top;
			nCX = m_rtWnd.Width();
			nCY = m_rtWnd.Height();
			graph.FillRectangle(&brushBG, nSX - 1, nSY - 1, nCX + 1, nCY + 1);
		}

		/*if (!m_strTitle.IsEmpty())
		{
			DrawTextToDest2(&graph,
							m_strTitle, &rtPS, &m_rtTitle,
							m_wszFontName, m_nFontHeightTitle,
							StringAlignmentNear,
							m_fontStyleTitle,
							m_crTitle);
		}*/
		if (!m_strMyPC.IsEmpty() )
		{
			DrawTextToDest2(&graph,
				m_strMyPC, &rtPS, &m_rcMyPC,
				m_wszFontName, rFontHeight,
				StringAlignmentNear,
				m_fontStyleKey,
				m_crTitle);
		}

		if (m_listFileAttach.GetSafeHwnd())
		{
			int nCntFileAttach = m_listFileAttach.GetFileItemCount();
			if (nCntFileAttach > 0)
			{
				if (!m_strSendSpeedTitle.IsEmpty())
				{
					DrawTextToDest2(&graph,
									m_strSendSpeedTitle, &rtPS, &m_rtSendSpeedTitle,
									m_wszFontName, m_nFontHeightKey,
									StringAlignmentNear,
									m_fontStyleKey,
									m_crKey);
				}
				if (!m_strSendSpeedValue.IsEmpty())
				{
					DrawTextToDest2(&graph,
									m_strSendSpeedValue, &rtPS, &m_rtSendSpeedValue,
									m_wszFontName, m_nFontHeightValue,
									StringAlignmentNear,
									m_fontStyleValue,
									m_crValue);
				}

				if (!m_strRemainTimeTitle.IsEmpty())
				{
					DrawTextToDest2(&graph,
									m_strRemainTimeTitle, &rtPS, &m_rtRemainTimeTitle,
									m_wszFontName, m_nFontHeightKey,
									StringAlignmentNear,
									m_fontStyleKey,
									m_crKey);
				}
				if (!m_strRemainTimeValue.IsEmpty())
				{
					DrawTextToDest2(&graph,
									m_strRemainTimeValue, &rtPS, &m_rtRemainTimeValue,
									m_wszFontName, m_nFontHeightValue,
									StringAlignmentNear,
									m_fontStyleValue,
									m_crValue);
				}

				_DrawProgressText(&graph, &rtPS);

				double fPctProgress = 0;
				fPctProgress = ((double)m_dwCurSendSize * 100) / (double)m_dwTotalSize;
				_DrawProgressBar(&graph, fPctProgress, &m_rtFileSizeProgress );

			}
		}

		if(m_bExpand)
		{
			Pen penCenterline(m_crCenterline, 1);
			nSX = rtPS.left;
			nSY = (m_rtFileList.top) - rtPS.top - 1;
			nCX = m_rtWnd.Width();
			graph.DrawLine(&penBG,nSX, nSY, nSX + nCX, nSY);

			nSX = m_rtWnd.left;
			nSY = m_rtWnd.bottom - DEF_MEMOSEND_TOTAL_SPEED_HEIGHT - 1;
			nCX = m_rtWnd.Width();
			graph.DrawLine(&penBG,nSX, nSY, nSX + nCX, nSY);
		}
		
		//graph.DrawRectangle(&penBG, nSX, nSY, nCX, nCY);

		BitBlt(dc.GetSafeHdc(), nPX, nPY, psWidth, psHeight, hdcMemory, 0, 0, SRCCOPY);

		::SelectObject(hdcMemory, hbmpOld);
		::DeleteObject(hbmpMem);

	}

	::DeleteDC(hdcMemory);
}

void CMemoSendAttachWnd::OnSize(UINT nType, int cx, int cy)
{
	CWnd::OnSize(nType, cx, cy);

	m_rtWnd.SetRect(0, 0, cx, cy);

	int nSX = 0, nSY = 0, nCX = 0, nCY = 0, nEX = 0, nEY = 0;

	// ÷ Static
	/*nSX = DEF_MEMOSEND_TITLE_POS_LEFT_X;
	nSY = DEF_MEMOSEND_TITLE_POS_TOP_Y;
	nCX = cx;

	if (!m_strTitle.IsEmpty() && m_szTitle.cx == 0)
	{
		CRect rtTitle(0, 0, cx, 1000);
		RecalcTextRect(this, m_strTitle, m_wszFontName, m_nFontHeightTitle, m_fontStyleTitle, rtTitle, m_szTitle);		
	}
	nCX = m_szTitle.cx + 5;
	nCY = m_szTitle.cy;
	m_rtTitle.SetRect(nSX, nSY, nSX + nCX, nSY + nCY);*/
	
	if(m_pBtnExpand->GetSafeHwnd())
	{
		if (!m_strTitle.IsEmpty() && m_szTitle.cx == 0)
		{
			CRect rtTitle(0, 0, 500, 1000);
			RecalcTextRect(this, m_strTitle, m_wszFontName, m_nFontHeightTitle, m_fontStyleTitle, rtTitle, m_szTitle);		
		}
		nCX = m_szTitle.cx + 11;
		nCY = m_szTitle.cy;
		nSX = DEF_MEMOSEND_TITLE_POS_LEFT_X;
		nSY = DEF_MEMOSEND_TITLE_POS_TOP_Y;

		::MoveWindow(m_pBtnExpand->GetSafeHwnd(),nSX, nSY, nCX, nCY, TRUE );
	}

	_ReCalcTotalSpeedBar();
	
	// 'PC' ư
	if (m_pBtnFileAdd->GetSafeHwnd())
	{
		nCX = DEF_MEMOSEND_MYPC_WIDTH;
		nCY = DEF_MEMOSEND_MYPC_HEIGHT;
		nSX = m_rtWnd.right - DEF_MEMOSEND_FILEADD_POS_RIGHT_X - nCX;
		nSY = DEF_MEMOSEND_FILEADD_POS_TOP_Y;

		::MoveWindow(m_pBtnFileAdd->GetSafeHwnd(),nSX, nSY, nCX, nCY, TRUE );
	}

	if(!m_strMyPC.IsEmpty() && m_szMyPC.cx == 0)
	{
		CRect rtMyPC(0, 0, 500, 1000);
		RecalcTextRect(this, m_strMyPC, m_wszFontName, rFontHeight, m_fontStyleKey, rtMyPC, m_szMyPC);
	}

	CRect rcFileAdd(0, 0, 0, 0);
	::GetClientRect(m_pBtnFileAdd->GetSafeHwnd(), &rcFileAdd);
	nCX = m_szMyPC.cx;
	nCY = m_szMyPC.cy;
	nSX = nSX - 10 - nCX;
	nSY = DEF_MEMOSEND_TITLE_POS_TOP_Y;
	m_rcMyPC.SetRect(nSX, nSY, nSX + nCX, nSY + nCY );


	

	

	// ÷  Ʈ
	if (m_listFileAttach.GetSafeHwnd())
	{
		int nCntFileAttach = m_listFileAttach.GetFileItemCount();

		nSX = m_rtWnd.left;
		nSY = DEF_MEMOSEND_FILELIST_POS_TOP_Y + 1;
		nCX = cx;
		nCY = cy - DEF_MEMOSEND_FILELIST_POS_TOP_Y - DEF_MEMOSEND_TOTAL_SPEED_HEIGHT - 2;
		/*if (nCntFileAttach <= 0)
		{
			nSY = DEF_MEMOSEND_FILELIST_POS_TOP_Y2;
			nCY = cy - DEF_MEMOSEND_FILELIST_POS_TOP_Y2 - DEF_MEMOSEND_FILELIST_POS_BOTTOM_Y - 1;
		}*/
		
		m_rtFileList.SetRect(nSX, nSY, nSX + nCX, nSY + nCY);
		m_listFileAttach.MoveWindow(&m_rtFileList);
	}
}
void CMemoSendAttachWnd::FileAdd(CString strFilePath)
{
	if(m_listFileAttach.CheckFileAttach(strFilePath))
	{
		m_listFileAttach.AddFileItem(strFilePath);
	}
}

// unsigned int __stdcall SelectFilesThread( LPVOID pArg )
// {
// 	TCHAR szCurrentPath[MAX_PATH];
// 	GetCurrentDirectory(MAX_PATH,szCurrentPath);
// 
// 	HWND hWndParent = ((CWnd*)pArg)->GetSafeHwnd();
// 
// 	CString strMultiPath = _T("");
// 	POSITION startPosition;
// 
// 	CString strFileDlgFilter = _T("");
// 	CString str = _T("");
// 	str.LoadString(IDS_STRING167);
// 	strFileDlgFilter.Format(_T("%s(*.*, *.*) | *.*; *.*"), str);
// 
// 	CFileDialog fileDlg(TRUE, NULL, NULL, OFN_EXPLORER | OFN_HIDEREADONLY | OFN_ALLOWMULTISELECT, strFileDlgFilter, NULL);
// 	const int c_cMaxFiles = 10;
// 	const int c_cbBuffSize = (c_cMaxFiles * (MAX_PATH + 1)) + 1;
// 	fileDlg.GetOFN().lpstrFile = strMultiPath.GetBuffer(c_cbBuffSize);
// 	fileDlg.GetOFN().nMaxFile = c_cbBuffSize;
// 
// 	vector<CString> vecFilePath;
// 	if (fileDlg.DoModal() == IDOK)
// 	{
// 		startPosition = fileDlg.GetStartPosition();
// 		while (startPosition)
// 		{
// 			CString strPath = _T("");
// 			strPath = fileDlg.GetNextPathName(startPosition);
// 			vecFilePath.push_back(strPath);
// 		}
// 	}
// 	
// 	SetCurrentDirectory(szCurrentPath);
// 
// 	::SendMessage(hWndParent, WM_FILE_SELECTED, (WPARAM)&vecFilePath, NULL);
// 
// 	strMultiPath.ReleaseBuffer();
// 
// //	_endthreadex(0);
// 	return 1;
// }

LRESULT CMemoSendAttachWnd::OnFileSelected( WPARAM wParam, LPARAM lParam )
{
	vector<CString>* pVectorFiles = (vector<CString>*)wParam;

	if (this->GetSafeHwnd() && ::IsWindow(this->m_hWnd) )
	{
		vector<CString>::const_iterator itr = pVectorFiles->begin();
		for(; itr != pVectorFiles->end(); itr++)
		{
			CString strPath = *itr;
			if (m_listFileAttach.IsAlreadyFileList(strPath))
				continue;

			if (!m_listFileAttach.CheckFileAttach(strPath))
				break;

			if (!m_listFileAttach.AddFileItem(strPath))
				continue;
		}
	}

//	m_bSelFileDlgIsActive = false;

	return 0L;
}

void CMemoSendAttachWnd::OnBtnFileAdd()
{
	CString strMsg = _T("");

	m_listFileAttach.FileAddInitialize();
	if (!m_listFileAttach.CheckFileAttach())
		return;


	TCHAR szCurrentPath[MAX_PATH];
	GetCurrentDirectory(MAX_PATH,szCurrentPath);

	CString strMultiPath = _T("");
	POSITION startPosition;

	CString strFileDlgFilter = _T("");
	CString str = _T("");
	str.LoadString(IDS_STRING167);
	strFileDlgFilter.Format(_T("%s(*.*, *.*) | *.*; *.*"), str);

	m_pFileDlg = new CMemoFileDialog(strFileDlgFilter, this);
	
	if(NULL == m_pFileDlg)
	{
		return;
	}
	const int c_cMaxFiles = 10;
	const int c_cbBuffSize = (c_cMaxFiles * (MAX_PATH + 1)) + 1;
	m_pFileDlg->GetOFN().lpstrFile = strMultiPath.GetBuffer(c_cbBuffSize);
	m_pFileDlg->GetOFN().nMaxFile = c_cbBuffSize;

	vector<CString> vecFilePath;
    GET_MESSENGER_DLG()->RegisterMfcModalDlg(m_pFileDlg);
    int nRet = m_pFileDlg->DoModal();
    GET_MESSENGER_DLG()->UnRegisterMfcModalDlg(m_pFileDlg);

	if (nRet == IDOK)
	{
		startPosition = m_pFileDlg->GetStartPosition();
		while (startPosition)
		{
			CString strPath = _T("");
			strPath = m_pFileDlg->GetNextPathName(startPosition);
			vecFilePath.push_back(strPath);
		}
	}


	SetCurrentDirectory(szCurrentPath);

	::SendMessage(m_hWnd, WM_FILE_SELECTED, (WPARAM)&vecFilePath, NULL);

	strMultiPath.ReleaseBuffer();
}

LRESULT CMemoSendAttachWnd::OnUmMemosendFileSize(WPARAM wParam, LPARAM lParam)
{
	if (!m_listFileAttach.GetSafeHwnd())
		return 0L;

	ULONGLONG dwTotalSize = m_listFileAttach.GetFileItemTotalSizeAll();
	ULONGLONG dwCurSendSize = m_listFileAttach.GetFileItemCurSendSizeAll();	

	UpdateSize(dwTotalSize, dwCurSendSize);

	if (dwCurSendSize > 0 && !m_bSendStart)
	{
		m_bSendStart = TRUE;
		m_dtSendStart = COleDateTime::GetCurrentTime();
		Sleep(100);
	}

	if (m_bSendStart)
	{
		COleDateTimeSpan dtElapsed = COleDateTime::GetCurrentTime() - m_dtSendStart;
		double fSeconds = dtElapsed.GetTotalSeconds();

		UpdateSpeed(dwCurSendSize, fSeconds);
	}

	if (dwTotalSize == dwCurSendSize)
		m_bSendStart = FALSE;

	return 1L;
}

void CMemoSendAttachWnd::SetController(SendMemoController *pController)
{
	m_listFileAttach.SetController(pController);
}

void CMemoSendAttachWnd::SetModel(CNoteModel *pModel)
{
	m_listFileAttach.SetModel(pModel);
}

void CMemoSendAttachWnd::__ResourceLoad(BOOL bInit)
{
	if (m_listFileAttach.GetSafeHwnd())
	{
		m_listFileAttach.SetInitMsgText(LoadStringFromResource(IDS_STRING452));
	}
	if (m_pBtnFileAdd->GetSafeHwnd())
	{
		CButtonUI * pButton = m_pBtnFileAdd->GetControl();
		ASSERT(pButton);
		if(pButton != NULL)
		{
			pButton->SetNormalImage(_T("btn_pc_open_nor.png"));
			pButton->SetPushedImage(_T("btn_pc_open_pre.png"));
		}
	}

	if(m_pBtnExpand->GetSafeHwnd())
	{
		CCheckBoxUI* pCheckBox = m_pBtnExpand->GetControl();
		ASSERT(pCheckBox);
		if(pCheckBox != NULL)
		{
			pCheckBox->SetNormalImage(_T("file='img_main_favorite_arrowdown_nor.png' rinset='11,0,0,0'"));
			pCheckBox->SetSelectedImage(_T("file='img_main_favorite_arrowup_nor.png' rinset='11,0,0,0'"));
			pCheckBox->SetText(m_strTitle);
			int nFontCount = m_pBtnExpand->GetPaintManager()->GetCustomFontCount();
			m_pBtnExpand->GetPaintManager()->AddFontAt(nFontCount, m_wszFontName, 12, true, false, false);
			pCheckBox->SetFont(nFontCount);
			pCheckBox->SetTextPadding(CRect(0, 0, 11, 0));
		}
	}

	if(m_pCkBoxReserve->GetSafeHwnd())
	{
		CCheckBoxUI* pCheckBox = m_pCkBoxReserve->GetControl();
		ASSERT(pCheckBox);
		if(pCheckBox != NULL)
		{
			pCheckBox->SetNormalImage(_T("file='btn_chat_talk_checkboc_off.png' dest='0,2,13,13'"));
			pCheckBox->SetSelectedImage(_T("file='btn_chat_talk_checkboc_on.png' dest='0,2,13,13'"));
			pCheckBox->SetText(LoadStringFromResource(IDS_STRING572));
			pCheckBox->SetFont(GetDefaultFontIndex());
			pCheckBox->SetTextPadding(CRect(21, 0, 0, 0));
		}
	}

	SendMessage(WM_SIZE, NULL, NULL);
}

void CMemoSendAttachWnd::CloseModalDialog()
{
	if(m_pFileDlg->GetSafeHwnd() != NULL)
	{
		//Do not use GetParent, you'll get a null
		//because the message of CFileDialog is sealed
		//Do not use m_pFileDlg->EndDialog(IDCANCEL)
		//because m_pFileDlg is not the real window
		((CDialog*)(m_pFileDlg->GetParentDialog()))->EndDialog(IDCANCEL);
	}
	
}

void CMemoSendAttachWnd::DUINotify( TNotifyUI& msg )
{
	if(msg.sType == DUI_MSGTYPE_BUTTONDOWN)
	{
		if(msg.pSender->GetName() == NAME_MY_PC_BTN)
		{
			OnBtnFileAdd();
		}	
	}

	if(msg.sType == DUI_MSGTYPE_SELECTCHANGED)
	{
		if(msg.pSender->GetName() == NAME_RESERVE_CKBOX)
		{
			CWnd* pParent = GetParent();
			ASSERT(pParent);
			if(pParent != NULL)
			{
				pParent->PostMessage(WM_RESERVE_SELECT_CHANGED);
			}
		}
		else if(msg.pSender->GetName() == NAME_EXPAND_CKBOX)
		{
			ExpandAttachList(!m_bExpand);
		}
	}
}

void CMemoSendAttachWnd::_DrawProgressBar( Graphics* pGraphics, double dbProgress, CRect *pRcProgress )
{
	if(m_pImgProgressBG[0] == NULL || m_pImgProgressBG[1] == NULL ||
		m_pImgProgressBG[2] == NULL || m_pImgProgressFG == NULL)
	{
		return;
	}

	InterpolationMode interpolationMode = pGraphics->GetInterpolationMode();
	PixelOffsetMode pixelOffsetMode = pGraphics->GetPixelOffsetMode();
	pGraphics->SetInterpolationMode(InterpolationModeNearestNeighbor);
	pGraphics->SetPixelOffsetMode(PixelOffsetModeHalf);

	//draw background
	pGraphics->DrawImage(m_pImgProgressBG[0], pRcProgress->left, pRcProgress->top,
		m_pImgProgressBG[0]->GetWidth(), m_pImgProgressBG[0]->GetHeight());

	pGraphics->DrawImage(m_pImgProgressBG[1], pRcProgress->left + m_pImgProgressBG[0]->GetWidth(),
		pRcProgress->top, pRcProgress->Width() - m_pImgProgressBG[2]->GetWidth(), m_pImgProgressBG[1]->GetHeight());

	pGraphics->DrawImage(m_pImgProgressBG[2], pRcProgress->right - m_pImgProgressBG[2]->GetWidth(),
		pRcProgress->top, m_pImgProgressBG[2]->GetWidth(), m_pImgProgressBG[2]->GetHeight());

	//draw progress

	LONG lWidth = (LONG)pRcProgress->Width() * dbProgress / 100;
	pGraphics->DrawImage(m_pImgProgressFG, pRcProgress->left, pRcProgress->top,
		lWidth, m_pImgProgressFG->GetHeight());

	pGraphics->SetInterpolationMode(interpolationMode);
	pGraphics->SetPixelOffsetMode(pixelOffsetMode);
}

void CMemoSendAttachWnd::_DrawProgressText( Graphics* pGraphics, CRect *pRtPS)
{
	if(!m_strCurProgressSizeText.IsEmpty())
	{
		DrawTextToDest2(pGraphics,
			m_strCurProgressSizeText, pRtPS, &m_rtCurSendProgressText,
			m_wszFontName, m_nFontHeightKey,
			StringAlignmentFar,
			m_fontStyleKey,
			m_crKey);
	}

	if(!m_strTotalSizeText.IsEmpty())
	{
		DrawTextToDest2(pGraphics,
			m_strTotalSizeText, pRtPS, &m_rtTotalProgressText,
			m_wszFontName, m_nFontHeightValue,
			StringAlignmentNear,
			m_fontStyleValue,
			m_crValue);
	}
}

void CMemoSendAttachWnd::_ReCalcTotalSpeedBar()
{
	CRect rcWindow(0, 0, 0, 0);
	GetWindowRect(&rcWindow);

	int cx = rcWindow.Width();
	int cy = rcWindow.Height();
	
	int nSX = 0, nSY = 0, nCX = 0, nCY = 0, nEX = 0, nEY = 0;
	
	nSX = DEF_MEMOSEND_TOTAL_SPEED_NAME_LEFT_X;
	nSY = cy - DEF_MEMOSEND_TOTAL_SPEED_HEIGHT;
	if (!m_strSendSpeedTitle.IsEmpty() && m_szSendSpeedTitle.cx == 0)
	{
		CRect rtSendSpeedTitle(0, 0, 500, 1000);
		RecalcTextRect(this, m_strSendSpeedTitle, m_wszFontName, m_nFontHeightKey, m_fontStyleKey, rtSendSpeedTitle, m_szSendSpeedTitle);
	}
	nCX = m_szSendSpeedTitle.cx;
	nCY = DEF_MEMOSEND_TOTAL_SPEED_HEIGHT;
	m_rtSendSpeedTitle.SetRect(nSX, nSY, nSX + nCX, nSY + nCY);

	if(!m_strSendSpeedValue.IsEmpty())
	{
		CRect rtSendSpeedValue(0, 0, 500, 1000);
		RecalcTextRect(this, m_strSendSpeedValue, m_wszFontName, m_nFontHeightValue, m_fontStyleValue, rtSendSpeedValue, m_szSendSpeedValue);
	}
	nSX = m_rtSendSpeedTitle.right + DEF_MEMOSEND_TOTAL_SPEED_GAP;
	nCX = m_szSendSpeedValue.cx + DEF_MEMOSEND_TOTAL_SPEED_TIME_GAP;
	m_rtSendSpeedValue.SetRect(nSX, nSY, nSX + nCX, nSY + nCY);


	nSX = m_rtSendSpeedValue.right;
	if (!m_strRemainTimeTitle.IsEmpty() && m_szRemainTimeTitle.cx == 0)
	{
		CRect rtRemainTimeTitle(0, 0, 500, 1000);
		RecalcTextRect(this, m_strRemainTimeTitle, m_wszFontName, m_nFontHeightKey, m_fontStyleKey, rtRemainTimeTitle, m_szRemainTimeTitle);
	}
	nCX = m_szRemainTimeTitle.cx;
	m_rtRemainTimeTitle.SetRect(nSX, nSY, nSX + nCX, nSY + nCY);

	nSX = m_rtRemainTimeTitle.right + DEF_MEMOSEND_TOTAL_TIME_GAP;
	nCX = DEF_MEMOSEND_REMAINTIME_VALUE_WIDTH;
	m_rtRemainTimeValue.SetRect(nSX, nSY, nSX + nCX, nSY + nCY);

	CRect rcCkReserve(0, 0, 0, 0);
	rcCkReserve.SetRectEmpty();
	if(m_pCkBoxReserve->GetSafeHwnd())
	{
		CString strReserve = m_pCkBoxReserve->GetControl()->GetText();
		if(!strReserve.IsEmpty() && m_szReserve.cx == 0)
		{
			CRect rtReserve(0, 0, 500, 1000);
			RecalcTextRect(this, strReserve, m_wszFontName, rFontHeight, m_fontStyleKey, rtReserve, m_szReserve);
		}

		nCX = m_szReserve.cx + 21;
		nSX = cx - DEF_MEMOSEND_TOTAL_RESERVE_RIGHT_X - nCX;
		nSY = nSY + (DEF_MEMOSEND_TOTAL_SPEED_HEIGHT - m_szReserve.cy) / 2;
		nCY = m_szReserve.cy;
		::MoveWindow(m_pCkBoxReserve->GetSafeHwnd(),nSX, nSY, nCX, nCY, TRUE );
	}

	nCX = DEF_MEMOSEND_PROGRESS_WIDTH;
	nSX = nSX - DEF_MEMOSEND_TOTAL_RESERVE_PROGRESS_GAP - DEF_MEMOSEND_PROGRESS_WIDTH;
	nSY = cy - DEF_MEMOSEND_TOTAL_SPEED_HEIGHT + (DEF_MEMOSEND_TOTAL_SPEED_HEIGHT - DEF_MEMOSEND_PROGRESS_HEIGHT) / 2;
	nCY = DEF_MEMOSEND_PROGRESS_HEIGHT;
	m_rtFileSizeProgress.SetRect(nSX, nSY, nSX + nCX, nSY + nCY);

	if(!m_strTotalSizeText.IsEmpty())
	{
		CSize szProgress(0, 0);
		CRect rtProgress(0, 0, 500, 1000);
		RecalcTextRect(this, m_strTotalSizeText, m_wszFontName, m_nFontHeightValue,
			m_fontStyleValue, rtProgress, szProgress);

		nSY = cy - DEF_MEMOSEND_TOTAL_SPEED_HEIGHT;
		nCY = DEF_MEMOSEND_TOTAL_SPEED_HEIGHT;

		nEX = m_rtFileSizeProgress.left - DEF_MEMOSEND_TOTAL_SENDSIZE_PROGRESS_GAP;
		nSX = nEX - szProgress.cx;

		m_rtTotalProgressText.SetRect(nSX, nSY, nEX, nSY + nCY);
	}
	if (!m_strCurProgressSizeText.IsEmpty())
	{
		CSize szProgress(0, 0);
		CRect rtProgress(0, 0, 500, 1000);
		RecalcTextRect(this, m_strCurProgressSizeText, m_wszFontName, m_nFontHeightKey, 
			m_fontStyleKey, rtProgress, szProgress);


		nSY = cy - DEF_MEMOSEND_TOTAL_SPEED_HEIGHT;
		nCY = DEF_MEMOSEND_TOTAL_SPEED_HEIGHT;
		nEX = m_rtTotalProgressText.left;
		nSX = nEX - szProgress.cx;
		m_rtCurSendProgressText.SetRect(nSX, nSY, nEX, nSY + nCY);
	}

}

void CMemoSendAttachWnd::ExpandAttachList( BOOL bExpand )
{
	if(m_bExpand == bExpand)
	{
		return;
	}

	m_bExpand = bExpand;

	CWnd *pParentWnd = this->GetParent();

	ASSERT(pParentWnd);
	if (pParentWnd != NULL)
	{
		int nExpandCY = DEF_MEMOSEND_WND_HEIGHT - DEF_MEMOSEND_FILELIST_POS_TOP_Y - DEF_MEMOSEND_TOTAL_SPEED_HEIGHT;
		nExpandCY = m_bExpand ? nExpandCY : -nExpandCY;

		LONG wParam = m_bExpand ? WPARAM_EXPAND_ON : WPARAM_EXPAND_OFF;
		LONG lParam = nExpandCY;
		pParentWnd->PostMessage(WM_EXPAND_CHANGED, wParam, nExpandCY);
	}


}

CPoint CMemoSendAttachWnd::ReSizeWindow( CPoint* pPtRightBottom )
{
	int nLeft = 0, nRight = 0, nTop = 0, nBottom = 0;
	nBottom = pPtRightBottom->y;
	int nHeight = DEF_MEMOSEND_WND_HEIGHT;
	if(!m_bExpand)
	{
		m_listFileAttach.ShowWindow(SW_HIDE);
		nHeight = DEF_MEMOSEND_FILELIST_POS_TOP_Y + DEF_MEMOSEND_TOTAL_SPEED_HEIGHT;
	}
	else
	{
		m_listFileAttach.ShowWindow(SW_SHOW);	
	}

	nTop = nBottom - nHeight;
	nRight = pPtRightBottom->x;

	CRect rcWindow(0, 0, 0, 0);
	rcWindow.SetRect(nLeft, nTop, nRight, nBottom);

	MoveWindow(&rcWindow);

	CPoint ptRet(0, 0);
	ptRet.x = rcWindow.left;
	ptRet.y = rcWindow.top;

	return ptRet;
}

void CMemoSendAttachWnd::SetReserveCheck( bool bCheck )
{
	CCheckBoxUI* pCkBox = NULL;
	pCkBox = m_pCkBoxReserve->GetControl();
	ASSERT(pCkBox);
	if(pCkBox != NULL)
	{
		pCkBox->SetCheck(bCheck);
	}
}

bool CMemoSendAttachWnd::GetReserveCheck()
{
	CCheckBoxUI* pCkBox = NULL;
	pCkBox = m_pCkBoxReserve->GetControl();
	ASSERT(pCkBox);
	if(pCkBox != NULL)
	{
		return pCkBox->GetCheck();
	}

	return false;
}


IMPLEMENT_DYNAMIC(CMemoFileDialog, CFileDialog)

BEGIN_MESSAGE_MAP(CMemoFileDialog, CFileDialog)

END_MESSAGE_MAP()
CMemoFileDialog::CMemoFileDialog(CString strFilter,CWnd* parent):
CFileDialog(TRUE, NULL, NULL, OFN_EXPLORER | OFN_HIDEREADONLY | OFN_ALLOWMULTISELECT | OFN_ENABLESIZING , strFilter, parent, 0, FALSE) 
{
	m_bClose = FALSE;
}
CMemoFileDialog::~CMemoFileDialog(){
}

void CMemoFileDialog::OnInitDone()
{
	pParentWnd = GetParent();
}

CDialog* CMemoFileDialog::GetParentDialog()
{
	return (CDialog*)pParentWnd;
}
